diff -urN axel-2.4/axel.c axel-2.4.tr/axel.c
--- axel-2.4/axel.c	2009-04-27 16:19:03.000000000 +0200
+++ axel-2.4.tr/axel.c	2012-07-01 20:43:18.832123867 +0200
@@ -267,6 +267,7 @@
 	int hifd, i;
 	long long int remaining,size;
 	struct timeval timeval[1];
+	static time_t tend = 0;
 	
 	/* Create statefile if necessary				*/
 	if( gettime() > axel->next_state )
@@ -302,7 +303,16 @@
 			return;
 		}
 	}
-	
+
+	/* extra disconnects can improve downloadspeed @ youtube and so on... /TR ;) */
+	if (axel->conf->reconnect_every)
+	if (tend < time(0))
+	for( i = 0; i < axel->conf->num_connections; i ++ ) {
+ 		axel->conn[i].enabled = 0;
+		conn_disconnect( &axel->conn[i] );
+		tend = time(0) + axel->conf->reconnect_every;
+	}
+
 	/* Handle connections which need attention			*/
 	for( i = 0; i < axel->conf->num_connections; i ++ )
 	if( axel->conn[i].enabled ) {
diff -urN axel-2.4/conf.c axel-2.4.tr/conf.c
--- axel-2.4/conf.c	2009-04-27 16:19:03.000000000 +0200
+++ axel-2.4.tr/conf.c	2012-07-01 20:31:48.549196783 +0200
@@ -136,6 +136,7 @@
 	conf->max_speed			= 0;
 	conf->verbose			= 1;
 	conf->alternate_output		= 0;
+	conf->reconnect_every		= 0;
 	
 	conf->search_timeout		= 10;
 	conf->search_threads		= 3;
diff -urN axel-2.4/conf.h axel-2.4.tr/conf.h
--- axel-2.4/conf.h	2009-04-27 16:19:03.000000000 +0200
+++ axel-2.4.tr/conf.h	2012-07-01 20:31:48.552530099 +0200
@@ -37,6 +37,7 @@
 	int max_speed;
 	int verbose;
 	int alternate_output;
+	int reconnect_every;
 	
 	if_t *interfaces;
 	
diff -urN axel-2.4/text.c axel-2.4.tr/text.c
--- axel-2.4/text.c	2009-04-27 16:19:03.000000000 +0200
+++ axel-2.4.tr/text.c	2012-07-01 20:38:55.626883104 +0200
@@ -42,6 +42,7 @@
 static struct option axel_options[] =
 {
 	/* name			has_arg	flag	val */
+	{ "reconnect-every",	1,	NULL,	'r' },
 	{ "max-speed",		1,	NULL,	's' },
 	{ "num-connections",	1,	NULL,	'n' },
 	{ "output",		1,	NULL,	'o' },
@@ -90,7 +91,7 @@
 	{
 		int option;
 		
-		option = getopt_long( argc, argv, "s:n:o:S::NqvhVaH:U:", axel_options, NULL );
+		option = getopt_long( argc, argv, "s:n:o:S::NqvhVar:H:U:", axel_options, NULL );
 		if( option == -1 )
 			break;
 		
@@ -131,6 +132,13 @@
 		case 'a':
 			conf->alternate_output = 1;
 			break;
+		case 'r':
+			if( !sscanf( optarg, "%i", &conf->reconnect_every ) )
+			{
+				print_help();
+				return( 1 );
+			}
+			break;
 		case 'N':
 			*conf->http_proxy = 0;
 			break;
@@ -549,6 +557,7 @@
 		"-q\tLeave stdout alone\n"
 		"-v\tMore status information\n"
 		"-a\tAlternate progress indicator\n"
+		"-r x\tSpecify maximum time of a connection in seconds\n"
 		"-h\tThis information\n"
 		"-V\tVersion information\n"
 		"\n"
@@ -566,6 +575,7 @@
 		"--quiet\t\t\t-q\tLeave stdout alone\n"
 		"--verbose\t\t-v\tMore status information\n"
 		"--alternate\t\t-a\tAlternate progress indicator\n"
+		"--reconnect-every\t-r x\tSpecify maximum time of a connection in seconds\n"
 		"--help\t\t\t-h\tThis information\n"
 		"--version\t\t-V\tVersion information\n"
 		"\n"
